#include "SHMClient.hpp"


using namespace boost::interprocess;

static const cv::String keys =
//pas de tabulation!!!
	"{ help       |  | Affiche l'aide}"
	"{ cam-id     |1 | id de la camera}"
	"{ out-fps    |25| largeur image sortie}"
	"{ udp-url    |0 | hauteur image sortie}"
	"{ udp-port   |  | transforme l'image au format opencv}"
;

SHMClient::SHMClient(int argc, char *argv[])
{
	init(argc, argv);
}

SHMClient::~SHMClient()
{
	delete segment;
}

std::string SHMClient::getNomSHM()const
{
	return nomSHM;
}

data* SHMClient::getPtrDonnees()const
{
	return d;
}

/**
 * Retourne le nombre de fps donne par l'utilisateur en option.
 */
int SHMClient::getFPS()const
{
	return fps;
}

void SHMClient::init(int argc, char *argv[])
{
	printf("argc : %d\n", argc);
	for(int i = 0 ; i < argc ; ++i)
		printf("%s\n", argv[i]);
	/**
	 * Parsing des options utilisateurs.
	 */
	ArgumentsSHMClient* options = parseArgument(argc, argv);

	/**
	 * Initialisation de la memoire.
	 */
	nomSHM = genereNomSHM(options->camId);
	segment = ouvrirMemoire(nomSHM);

	// Find the object
	printf("SHMClient::init\n");
	// d = (data*)malloc(sizeof(char*));
	d = segment->find<data>("video").first;
	printf("SHMClient::init2\n");
	if(d != NULL)
		printf("Champs video de la memoire partagee trouve.\n");
	else
		BOOST_LOG_TRIVIAL(error) << "main_shm_client.cpp "
				"Impossible de trouver les donnees.";

	delete options;
}

/**
 * Ouvre une zone de memoire partagee ayant pour nom nomSM.
 * @param	nomSM nom de la memoire partagee.
 * @return	objet permettant de gerer la memoire partagee.
 */
managed_shared_memory* SHMClient::ouvrirMemoire(std::string nomSM)
{
	int numTentative = 1;
	while(true){
		printf("Tentative de se connecter a %s num %d\n", nomSM.c_str(), numTentative);
		try{
			managed_shared_memory* segment = new 
					managed_shared_memory(open_only, nomSM.c_str());
			return segment;
		}catch(interprocess_exception e){
			BOOST_LOG_TRIVIAL(debug) << "main_shm_client.cpp" <<
					e.what();
		}
		++numTentative;
		sleep(3);
	}
}

/**
 * Fonction qui analyse la commande inseree par l'utilisateur afin de determiner les
 * options du client.
 * @param  argc nbr d'argument. Recopier a partir du main.
 * @param  argv valeur des arguments. Recopier a partir du main.
 * @return      Retourne une liste des options client.
 */
ArgumentsSHMClient* SHMClient::parseArgument(int argc, const char* const argv[])
{
	cv::CommandLineParser parser(argc, argv, keys);
	ArgumentsSHMClient* d = new ArgumentsSHMClient();

	if(parser.has("help"))
		parser.printMessage();
	d->camId = parser.get<int>("cam-id");
	d->camId = parser.get<int>("cam-id");
	d->fps = parser.get<int>("out-fps");
	fps = parser.get<int>("out-fps");
	d->udpUrl = parser.get<int>("udp-url");
	d->udpPort = parser.get<int>("udp-port");

	if (!parser.check()){
		parser.printErrors();
	}
	return d;
}