#include "ServerSHM.hpp"

static const cv::String keys =
//pas de tabulation!!!
	"{ help       |  | Affiche l'aide}"
	"{ cam-url    |  | url camera}"
	"{ cam-id     |1 | id de la camera}"
	"{ out-width  |0 | largeur image sortie}"
	"{ out-height |0 | hauteur image sortie}"
	"{ opencv     |  | transforme l'image au format opencv}"
;

ServerSHM::ServerSHM(int argc, const char* const argv[])
		: width(0), height(0), video(NULL), fm(NULL)
{
	parseArgument(argc, argv);
	initVideo();
	initSHM();
	lancerLecture();
}

ServerSHM::~ServerSHM()
{
	printf("Suppr memoire partagee : %s\n", nomSHM.c_str());
	boost::interprocess::shared_memory_object::remove(nomSHM.c_str());
}


void ServerSHM::parseArgument(int argc, const char* const argv[])
{
	cv::CommandLineParser parser(argc, argv, keys);

	if(parser.has("help"))
		parser.printMessage();
	convOpencv	= parser.has("opencv");
	url			= parser.get<std::string>("cam-url");
	width		= parser.get<int>("out-width");
	height		= parser.get<int>("out-height");
	camId		= parser.get<int>("cam-id");
	// std::cout << "url :" << url << std::endl <<
	// 		"width :" << width << std::endl <<
	// 		"height : " << height << std::endl <<
	// 		"id : " << camId << std::endl;

	if (!parser.check()){
		parser.printErrors();
	}
}

void ServerSHM::initSHM()
{
	//nom de la memoire partagee
	nomSHM = "camera" + camId;

	//on cree la memoire partagee
	std::cout << "nomSHM : " << nomSHM.c_str() << " camId : " << camId << std::endl;
	try{
		// if(boost::interprocess::managed_shared_memory segment2(open_only, "MySharedMemory")){
		// 	boost::interprocess::shared_memory_object::remove("MySharedMemory");
		// 	printf("suppr precedente memoire\n");
		// 	delete segment2;
		// }
		boost::interprocess::managed_shared_memory	
				segment(boost::interprocess::create_only, 
						"MySharedMemory", 
						sizeof(data) * 8);

		data d;
		d.width =		480;
		d.height =		576;
		d.nbCanaux =	3;
		d.numImage =	0;
		objetPartage = segment.construct<data>
				("video")//name of the object
				(d);
	}catch(boost::interprocess::interprocess_exception e){
		BOOST_LOG_TRIVIAL(debug) << "ServerSHM.cpp " <<
				e.what();
		exit(EXIT_FAILURE);
	}

	//on cree la classe que l'on va mettre dans la memoire partagee
	// data d;
	// d.width =		width;
	// d.height =		height;
	// d.nbCanaux =	3;
	// d.numImage =	0;
	// std::cout << "fin creation memoire\n";
	// objetPartage = segment.construct<data>
	// 		("video")//name of the object
	// 		(d);
	// segment.construct<std::string>
	// 		("video")//name of the object
	// 		("c4est bon");

	// boost::interprocess::managed_shared_memory segment2(boost::interprocess::open_only, "myshared");
	printf("fin ServerSHM::initSHM\n");
}

void ServerSHM::initVideo()
{
	video = new Capture(url);

	if(width <= 0)
		width = video->getLargeur();
	if(height <= 0 )
		height = video->getHauteur();
	if(convOpencv){
		//cette option est activee avec l'option --opencv
		enum PixelFormat formatPixel = PIX_FMT_BGR24;
		fm	= new FluxVideoModifie(video, width, height, formatPixel);
	}else{
		fm	= new FluxVideoModifie(video, width, height);
	}
	std::cout << "fin ServerSHM::initVideo\n" << std::endl;
}

void ServerSHM::lancerLecture()
{
	while(true){
		video->lire();
		fm->modifier();
		++(objetPartage->numImage);
		memcpy(objetPartage->data, fm->getPtrDataModifiees()->data[0], tailleData);//fm.getSize());

		// cv::Mat img(fm.getHauteur(),
		// 		fm.getLargeur(),
		// 		CV_8UC3,
		// 		objetPartage->data);
		// imshow("video", img);
		// cv::waitKey(3);
		sleep(0.01);
	}
}