/*
 * FluxVideoModifie.hpp
 *
 *  Created on: Jun 12, 2013
 *      Author: exploit
 */

#ifndef FLUXVIDEOMODIFIE_HPP_
#define FLUXVIDEOMODIFIE_HPP_

#include "Capture.hpp"

class FluxVideoModifie {
public:
	FluxVideoModifie(Capture*, int, int, enum PixelFormat);
	FluxVideoModifie(Capture*, enum PixelFormat);
	FluxVideoModifie(Capture*, int, int);

	FluxVideoModifie(const FluxVideoModifie &);
	virtual ~FluxVideoModifie();

	int getHauteur()const;
	int getLargeur()const;
	int getSize()const;	
	enum PixelFormat getFormat()const;
	AVFrame* getPtrDataModifiees()const;

	bool modifier();
protected:
	void initSwsContext();
	AVFrame* initFrameModification();

	/*
	 * Flux qui sera modifié par cette classe.
	 */
	Capture* model;

	/*
	 * Structure qui permettrat de redimensionner l'image.
	 * Si == NULL, on considére qu'aucun redimensionnement sur
	 * l'image ne doit être éffectué.
	 */
	SwsContext* contextTraitementImage;

	/*
	 * Lagueur de sortie.
	 */
	int largueurSortie;

	/*
	 * Hauteur de l'image en sortie
	 */
	int hauteurSortie;

	/*
	 * Format de l'imag ens sortie
	 */
	enum PixelFormat formatSortie;

	/*
	 * Data au format souhaite.
	 */
	AVFrame* frameModifie;

	/**
	 * Taille de l'image creee en octet.
	 */
	int tailleSortie;
};

#endif /* FLUXVIDEOMODIFIE_HPP_ */
