/*
 * timer.hpp
 *
 *  Created on: Jun 26, 2013
 *      Author: exploit
 */

#ifndef TIMER_HPP_
#define TIMER_HPP_

#include <boost/chrono.hpp>

using namespace boost::chrono;

class Timer
{
public:
	Timer() : start(steady_clock::now())
	{}

	int tempsEcouleSecondes()const
	{
		return (int) (tempsEcoule().count() *
				((double)steady_clock::period::num / steady_clock::period::den));
	}

	typename steady_clock::duration tempsEcoule()const
	{
		return steady_clock::now() - start;
	}

private:
	typename steady_clock::time_point start;
	steady_clock chronometre;
};

class CompteARebour
{
private:
	Timer* chrono;
	int debut;//en seconde
	int duree;//en seconde

public:
	CompteARebour(Timer* t, int theDuree)
				: chrono(t), debut(t->tempsEcouleSecondes()), duree(theDuree)
	{}

	void retourAZeros()
	{
		debut = chrono->tempsEcouleSecondes();
	}

	bool estEcoule()const
	{
		bool finTemps = (chrono->tempsEcouleSecondes() - debut) >= duree;
		return finTemps;
	}

	std::string toString()const
	{
		std::ostringstream oss;
		oss << "debut : " << debut << " duree : " << duree << ".\n";
		return oss.str();
	}

	int getDuree() const {
		return duree;
	}

	/*
	 * Modifie la durée avant que le compte à rebour ne soit écoulé.
	 */
	void setDuree(int duree) {
		this->duree = duree;
	}
};

#endif /* TIMER_HPP_ */
